/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.4.24452 at Wed Dec 17 03:35:17 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2013.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/* SKELETON for env functions */
/* Program generated by Cadvanced 6.3.0.2 19373  */
#define XSCT_CADVANCED

#if defined(_Windows) || defined(WIN32)
#include <WinSock.h>
#else
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SCT_VERSION_6_3
#include "scttypes.h"
#ifdef XINCLUDE_HS_FILE
#include "component.hs"
#endif
#ifdef XENV_INC
#include XENV_INC
#endif
#include "component.ifc"
#include "cucf.h"
#include "RFC1155_SMI_asn1coder.h"
#include "RFCxxxx_MIBs_asn1coder.h"
#include "RFC1157_SNMP_asn1coder.h"

#ifndef XENV_BUF
#define XENV_BUF(stmt) stmt
#endif

#ifndef XENV_STATIC_VARS
  #if defined(_Windows) || defined(WIN32)
#define XENV_STATIC_VARS static SOCKET manager_sock = -1; /* Socket descriptor */
  #else
    #define XENV_STATIC_VARS static int manager_sock = -1; /* Socket descriptor */
  #endif
#endif
XENV_STATIC_VARS

static unsigned char fIsAgentConnected = 0;
static struct sockaddr_in manager_addr;
static struct sockaddr_in agent_addr;

void exiterr( char* signal, char *func )
{
#if defined(_Windows) || defined(WIN32)
    printf("%s :  ERROR in %s : %d\n", signal, func, WSAGetLastError());
    closesocket(manager_sock);
    WSACleanup();
#else
    printf("%s :  ERROR in %s : %d\n", signal, func, errno);
#endif
    exit(1);
}

#ifndef XNOGLOBALNODENUMBER
/*---+---------------------------------------------------------------
     xGlobalNodeNumber  extern
-------------------------------------------------------------------*/
#ifndef XENV_NODENUMBER
#define XENV_NODENUMBER return 1;
#endif

extern int xGlobalNodeNumber(void)
{
  /* Assign a unique global system Id to each SDL system in a cluster of systems. */
  XENV_NODENUMBER
}
#endif


#ifndef XNOINITENV
/*---+---------------------------------------------------------------
     xInitEnv  extern
-------------------------------------------------------------------*/
#ifndef XENV_INIT
#define XENV_INIT
#endif

extern void xInitEnv(void)
{
  /* Code to initialize your SDL-system environment may be inserted here */
  XENV_INIT

#if defined(_Windows) || defined(WIN32)
  WSADATA wsdata;
  WORD wVersionRequested;
#endif

  printf("InitEnv:\n");

  memset(&manager_addr, '\0', sizeof(manager_addr));
  manager_addr.sin_family = AF_INET;
  manager_addr.sin_port = htons(162);
  manager_addr.sin_addr.s_addr = INADDR_ANY;

  memset(&agent_addr, '\0', sizeof(agent_addr));
  agent_addr.sin_family = AF_INET;
  agent_addr.sin_port = htons(161);
  agent_addr.sin_addr.s_addr = inet_addr("9.156.33.7"); /* network printer address */

#if defined(_Windows) || defined(WIN32)
  wVersionRequested = MAKEWORD(2,2);

  printf("InitEnv: Registering in the socket library... ");

  if (WSAStartup(wVersionRequested, &wsdata) != 0)
    exiterr("InitEnv", "WSAStartup");

  printf("Done!\n");
#endif

  printf("InitEnv: Creating manager socket... ");

  manager_sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if (manager_sock < 0)
    exiterr("InitEnv", "socket");

  printf("Done!\n");

  printf("InitEnv: Binding manager socket to <local IP>:%d ... ", ntohs(manager_addr.sin_port));

  if (bind(manager_sock, (struct sockaddr *)&manager_addr, sizeof(manager_addr)) != 0)
    exiterr("InitEnv", "bind");

  printf("Done!\n");

  fIsAgentConnected = 0;

  printf("InitEnv: SNMP agent address = %s:%d\n", inet_ntoa(agent_addr.sin_addr), ntohs(agent_addr.sin_port));

  printf("InitEnv: Initialized!\n");


#ifdef XTRACE
  xPrintString("xInitEnv called\n");
#endif
}
#endif


#ifndef XNOCLOSEENV
/*---+---------------------------------------------------------------
     xCloseEnv  extern
-------------------------------------------------------------------*/
#ifndef XENV_CLOSE
#define XENV_CLOSE
#endif

extern void xCloseEnv(void)
{
  /* Code to bring down the environment in a controlled manner
     may be inserted here. */
  XENV_CLOSE

  printf("CloseEnv: Closing manager socket...");
#if defined(_Windows) || defined(WIN32)
  closesocket(manager_sock);
#else
  close(manager_sock);
#endif

  manager_sock = -1;
  fIsAgentConnected = 0;
  
  printf("Done!\n");

#ifdef XTRACE
  xPrintString("xCloseEnv called\n");
#endif
}
#endif


/*---+---------------------------------------------------------------
     Macros for xOutEnv
-------------------------------------------------------------------*/
#ifndef OUT_LOCAL_VARIABLES
#define OUT_LOCAL_VARIABLES
#endif

#ifndef IF_OUT_SIGNAL
#define IF_OUT_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  if (((*SignalOut)->NameNode) == SIGNAL_NAME) {
#define END_IF_OUT_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  }
#endif

#ifndef OUT_SIGNAL1
#define OUT_SIGNAL1(SIGNAL_NAME, SIGNAL_NAME_STRING)
#endif

#ifndef OUT_SIGNAL2
#define OUT_SIGNAL2(SIGNAL_NAME, SIGNAL_NAME_STRING)
#endif

#ifndef XENV_ENC
#define XENV_ENC(stmt) stmt
#endif

#ifndef XENV_OUT_START
#define XENV_OUT_START
#endif

#ifndef RELEASE_SIGNAL
#define RELEASE_SIGNAL   xReleaseSignal(SignalOut); return;
#endif

/* NOTE: Standard SNMP request port - 161, trap port - 162 */

/*---+---------------------------------------------------------------
     xOutEnv  extern
-------------------------------------------------------------------*/
extern void xOutEnv( xSignalNode *SignalOut )
{
  OUT_LOCAL_VARIABLES

  char*   data;
  int     datalen, i;
  tBuffer Buf = 0;

#ifdef XTRACE
#ifdef XIDNAMES
  char  Temp[100];
  sprintf(Temp, "xOutEnv:  %s has been received by env\n",
          (*SignalOut)->NameNode->Name );
  xPrintString(Temp);
#else
  xPrintString("xOutEnv:  One signal has been received by env\n");
#endif
#endif

  XENV_OUT_START

  /* Signals going to the env via the channel Signal_env */


    /* Signal snmp_request */
    IF_OUT_SIGNAL(snmp_request,"snmp_request")
/*
      OUT_SIGNAL1(snmp_request,"snmp_request")
      XENV_BUF(BufInitWriteMode(Buf));
      XENV_ENC(ASN1_ENCODE(Buf, (tASN1TypeInfo *)&yASN1_Message,
        (void *)&((yPDef_snmp_request *)(*SignalOut))->Param1));
      OUT_SIGNAL2(snmp_request,"snmp_request")
      XENV_BUF(BufCloseWriteMode(Buf));
*/
      printf("Signal snmp_request: Encoding request... ");

      BufInitBuf( Buf, bms_SmallBuffer );
      ERSetRule( Buf, er_BER | er_Definite );
      BufInitWriteMode( Buf );
      BEREncode(Buf, (tASN1TypeInfo *)&yASN1_Message,(void *)&((yPDef_snmp_request *)(*SignalOut))->Param1);
      BufCloseWriteMode( Buf );
      BufInitReadMode( Buf );
      datalen = BufGetDataLen( Buf );
      data = BufGetSeg( Buf, datalen );

      printf("Done!\n");

      printf("Signal snmp_request: datalen = %d, ", datalen);
      printf( "   BER = " );
      for ( i = 0; i < datalen; i++ )
      {
        printf( "%x ", (unsigned char)data[i] );
      }
      printf("\n");

      printf("Signal snmp_request: Sending data... ");

#if defined(_Windows) || defined(WIN32)
      i = send(manager_sock, data, datalen, 0);
#else
      i = write(manager_sock, data, datalen);
#endif
      if ( i < 0 )
      {
#if defined(_Windows) || defined(WIN32)
        exiterr("Signal snmp_request", "send");
#else
        exiterr("Signal snmp_request", "read");
#endif
      }
      else if ( i < datalen )
      {
        printf("Signal snmp_request:  WARNING : Only %d bytes sent\n", i);
      }

      BufCloseReadMode( Buf );
      BufCloseBuf(Buf);

      printf("Done!\n");

      RELEASE_SIGNAL
    END_IF_OUT_SIGNAL(snmp_request,"snmp_request")

    /* Signal Init */
    IF_OUT_SIGNAL(Init,"Init")
/*
      OUT_SIGNAL1(Init,"Init")
      OUT_SIGNAL2(Init,"Init")
*/
      printf("Signal Init: Connecting to agent... ");
      
      if (connect(manager_sock,(struct sockaddr *)&agent_addr,sizeof(agent_addr)) != 0) 
        exiterr("Signal Init", "Cannot connect to agent");

      fIsAgentConnected = 1;

      printf("Done!\n");

      RELEASE_SIGNAL
    END_IF_OUT_SIGNAL(Init,"Init")

    /* Signal Close */
    IF_OUT_SIGNAL(Close,"Close")
/*
      OUT_SIGNAL1(Close,"Close")
      OUT_SIGNAL2(Close,"Close")
*/
      printf("Signal Close: Closing... Done!\n");

      RELEASE_SIGNAL
    END_IF_OUT_SIGNAL(Close,"Close")
}


/*---+---------------------------------------------------------------
     Macros for xInEnv
-------------------------------------------------------------------*/
#ifndef IN_LOCAL_VARIABLES
#define IN_LOCAL_VARIABLES \
  xSignalNode SignalIn;
#endif

#ifndef IN_SIGNAL1
#define IN_SIGNAL1(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  SignalIn = xGetSignal(SIGNAL_NAME, xNotDefPId, xEnv);
#endif

#ifndef IN_SIGNAL2
#define IN_SIGNAL2(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  SDL_Output(SignalIn xSigPrioPar(xDefaultPrioSignal), (xIdNode *)0);
#endif

#ifndef IF_IN_SIGNAL
#define IF_IN_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  if (TEST_IF_IN_SIGNAL(SIGNAL_NAME)) {
#define END_IF_IN_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  }
#endif

#ifndef TEST_IF_IN_SIGNAL
#define TEST_IF_IN_SIGNAL(SIGNAL_NAME)  0
#endif

#ifndef XENV_DEC
#define XENV_DEC(stmt) stmt
#endif

#ifndef XENV_IN_START
#define XENV_IN_START
#endif

#ifndef XENV_IN_END
#define XENV_IN_END
#endif


/*---+---------------------------------------------------------------
     xInEnv  extern
-------------------------------------------------------------------*/
#ifndef XTENV
extern void xInEnv ( SDL_Time Time_for_next_event )
#else
extern SDL_Duration xInEnv ( SDL_Time Time_for_next_event )
#endif
{
  IN_LOCAL_VARIABLES

  char reply[1028];
  int datalen, i;
  tBuffer Buf = 0;

#ifdef XTRACE
#ifndef XNOXINENVTRACE
  xPrintString( "xInEnv: Called!\n");
#endif
#endif

  XENV_IN_START

  /* Signals comming from the env via the channel Signal_env */

  /* Signal snmp_reply */
/*
  IF_IN_SIGNAL(snmp_reply,"snmp_reply")
    XENV_BUF(BufInitReadMode(Buf));
    IN_SIGNAL1(snmp_reply,"snmp_reply")
    XENV_DEC(ASN1_DECODE(Buf, (tASN1TypeInfo *)&yASN1_Message,
      (void *)&((yPDef_snmp_reply *)SignalIn)->Param1));
    IN_SIGNAL2(snmp_reply,"snmp_reply")
    XENV_BUF(BufCloseReadMode(Buf));
  END_IF_IN_SIGNAL(snmp_reply,"snmp_reply")
*/

  if (fIsAgentConnected)
  {
    printf("Signal snmp_reply: Receiving data... ");

#if defined(_Windows) || defined(WIN32)
    datalen = recv(manager_sock, reply, sizeof(reply), 0);
#else
    datalen = read(manager_sock, reply, sizeof(reply));
#endif

    if ( datalen < 0 )
    {
#if defined(_Windows) || defined(WIN32)
      exiterr("snmp_reply", "recv");
#else
      exiterr("snmp_reply", "read");
#endif
    }
    else if ( datalen == 0 )
    {
        printf("snmp_reply :  Connection has been gracefully closed\n");
    }
    else
    {
        printf("Done!\n");

        printf("Signal snmp_reply: Received %d bytes, ", datalen);
        printf("BER = " );
        for ( i = 0; i < datalen; i++ )
        {
          printf("%x ", (unsigned char)reply[i]);
        }
        printf("\n");

        printf("Signal snmp_reply: Decoding data... ");

        BufInitBuf( Buf, bms_SmallBuffer );
        BufInitWriteMode( Buf );
        BufPutSeg( Buf, reply, datalen );
        BufCloseWriteMode( Buf );
        ERSetRule( Buf, er_BER | er_Definite );
        BufInitReadMode(Buf);
        IN_SIGNAL1(snmp_reply,"snmp_reply")
        BERDecode(Buf, (tASN1TypeInfo *)&yASN1_Message, (void *)&((yPDef_snmp_reply *)SignalIn)->Param1);
        IN_SIGNAL2(snmp_reply,"snmp_reply")
        BufCloseReadMode(Buf);
        BufCloseBuf(Buf);

        printf("Done!\n");
    }
  }

  XENV_IN_END

#ifdef XTENV
  return SDL_Time_Lit((xint32)0,(xint32)0);
#endif

}
