/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.4.24452 at Wed Dec 17 03:35:17 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2013.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*
################################################################################
##      env.c corresponding to file component.ifc
## 
## Generated by: Targeting Expert - Version 6.3.0.2 19373 
## Generated on: Tue Jan 11 17:21:04 2011
## 
## ATTENTION!
## The user must modify this file in the appropriate sections surrounded by 
## "BEGIN User Code" and "END User Code"
## All modifications done within these sections will be saved, all the other
## ones will be lost when creating this file again.
## Do NOT delete, add or modify the lines "BEGIN User Code" and 
## "END User Code"
## Do not edit this Line, it's used for downward compatibility
################################################################################
*/
#ifndef __ENV_C_ 
#define __ENV_C_ 

#if defined(_Windows) || defined(WIN32)
#include <WinSock.h>
#else
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ml_typ.h" 

#include "component.ifc" 

#define XENV_ENC( x ) x
#define XENV_DEC( x ) x

/*Coder files*/
#include "cucf.h"
#include "RFC1155_SMI_asn1coder.h"
#include "RFCxxxx_MIBs_asn1coder.h"
#include "RFC1157_SNMP_asn1coder.h"


/* BEGIN User Code (global section)*/
/* It is possible to define some global variables here */
/* or to include other header files.                   */

#if defined(_Windows) || defined(WIN32)
static SOCKET manager_sock = -1; /* Socket descriptor */
#else
static int manager_sock = -1; /* Socket descriptor */
#endif
static unsigned char fIsAgentConnected = 0;
static struct sockaddr_in manager_addr;
static struct sockaddr_in agent_addr;

void exiterr( char* signal, char *func )
{
#if defined(_Windows) || defined(WIN32)
    printf("%s :  ERROR in %s : %d\n", signal, func, WSAGetLastError());
    closesocket(manager_sock);
    WSACleanup();
#else
    printf("%s :  ERROR in %s : %d\n", signal, func, errno);
#endif
    exit(1);
}

/*   END User Code (global section)*/

#ifdef XMK_USE_xInitEnv
/*
+------------------------------------------------------------------------------+
|  Functionname : xInitEnv                                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called by the Cmicro Kernel during initialization of the   |
|  SDL-System.                                                                 |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
void xInitEnv (void)
{

  /* BEGIN User Code (variable section)*/
  /* It is possible to define some variables here */
#if defined(_Windows) || defined(WIN32)
  WSADATA wsdata;
  WORD wVersionRequested;
#endif
  /*   END User Code (variable section)*/

  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("xInitEnv");
  #endif

  /* BEGIN User Code (init section) */
  /* Do the actions here to initialize your environment */
  printf("InitEnv:\n");

  memset(&manager_addr, '\0', sizeof(manager_addr));
  manager_addr.sin_family = AF_INET;
  manager_addr.sin_port = htons(162);
  manager_addr.sin_addr.s_addr = INADDR_ANY;

  memset(&agent_addr, '\0', sizeof(agent_addr));
  agent_addr.sin_family = AF_INET;
  agent_addr.sin_port = htons(161);
  agent_addr.sin_addr.s_addr = inet_addr("9.156.33.7"); /* network printer address */

#if defined(_Windows) || defined(WIN32)
  wVersionRequested = MAKEWORD(2,2);

  printf("InitEnv: Registering in the socket library... ");

  if (WSAStartup(wVersionRequested, &wsdata) != 0)
    exiterr("InitEnv", "WSAStartup");

  printf("Done!\n");
#endif

  printf("InitEnv: Creating manager socket... ");

  manager_sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if (manager_sock < 0)
    exiterr("InitEnv", "socket");

  printf("Done!\n");

  printf("InitEnv: Binding manager socket to <local IP>:%d ... ", ntohs(manager_addr.sin_port));

  if (bind(manager_sock, (struct sockaddr *)&manager_addr, sizeof(manager_addr)) != 0)
    exiterr("InitEnv", "bind");

  printf("Done!\n");

  fIsAgentConnected = 0;

  printf("InitEnv: SNMP agent address = %s:%d\n", inet_ntoa(agent_addr.sin_addr), ntohs(agent_addr.sin_port));

  printf("InitEnv: Initialized!\n");
  /*   END User Code (init section) */

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("xInitEnv");
  #endif
} /* END OF FUNCTION */
#endif /* ... XMK_USE_xInitEnv */

#ifdef XMK_USE_xInEnv
/*
+------------------------------------------------------------------------------+
|  Functionname : xInEnv                                                       |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called by the Cmicro Kernel continuously to retrieve       |
|  signals polled from the Environment.                                        |
|                                                                              |
|  The use of xInEnv() is not absolutely necessary in the case, where          |
|  the Cmicro Kernel is scaled to preemption, and all external Events are      |
|  put into the SDL-System via an Interrupt Service Routine, which is to be    |
|  written by the user.                                                        |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
+------------------------------------------------------------------------------+
*/
void xInEnv (XMK_xInEnv_PARTYPE XMK_xInEnv_PARNAME)
{

   XMK_SEND_TMP_VARS

   /* BEGIN User Code (variable section)*/
   /* It is possible to define some variables here      */
   /* or to insert a functionality which must be polled */

   char reply[1028];
   int datalen, i;
   tBuffer Buf = 0;

   /*   END User Code (variable section)*/

  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("xInEnv");
  #endif /* ... XMK_ADD_PRINTF_USER */

  /* BEGIN User Code <snmp_reply>_1 */
  if (fIsAgentConnected)
  /*   END User Code <snmp_reply>_1 */
  {
    yPDef_snmp_reply xmk_var;

    /* BEGIN User Code <snmp_reply>_2 */
    /* It is possible to insert any user code here. */

	printf("Signal snmp_reply: Receiving data... ");

#if defined(_Windows) || defined(WIN32)
    datalen = recv(manager_sock, reply, sizeof(reply), 0);
#else
    datalen = read(manager_sock, reply, sizeof(reply));
#endif

    if (datalen < 0)
	{
#if defined(_Windows) || defined(WIN32)
      exiterr("snmp_reply", "recv");
#else
      exiterr("snmp_reply", "read");
#endif
	}
    else if ( datalen == 0 )
    {
        printf("snmp_reply :  Connection has been gracefully closed\n");
    }
    else
    {
        printf("Done!\n");

        printf("Signal snmp_reply: Received %d bytes, ", datalen);
        printf("BER = " );
        for ( i = 0; i < datalen; i++ )
        {
          printf("%x ", (unsigned char)reply[i]);
        }
        printf("\n");

        printf("Signal snmp_reply: Decoding data... ");

        BufInitBuf( Buf, bms_SmallBuffer );
        BufInitWriteMode( Buf );
        BufPutSeg( Buf, reply, datalen );
        BufCloseWriteMode( Buf );
        ERSetRule( Buf, er_BER | er_Definite );
        BufInitReadMode(Buf);
        BERDecode(Buf, (tASN1TypeInfo *)&yASN1_Message, (void *)&(xmk_var.Param1));
        BufCloseReadMode(Buf);
        BufCloseBuf(Buf);

        printf("Done!\n");
    }

    /*   END User Code <snmp_reply>_2 */

    XMK_SEND_ENV( ENV,
                  snmp_reply,
                  xDefaultPrioSignal,
                  sizeof( yPDef_snmp_reply ),
                  &xmk_var,
    /* BEGIN User Code <snmp_reply>_3 */
                  GLOBALPID(0 /* enter process ID which should receive signal <snmp_reply> */,0));
    return;
    /*   END User Code <snmp_reply>_3 */
  }

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("xInEnv");
  #endif

} /* END OF FUNCTION */
#endif /* ... XMK_USE_xInEnv */

#ifdef XMK_USE_xOutEnv
/*
+------------------------------------------------------------------------------+
|  Functionname : xOutEnv                                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called by the Cmicro Kernel, if an SDL signal is to be     |
|  sent to the environment.                                                    |
|  The user must take care for that for each possible signal there is an       |
|  appropriate handling. If a signal was handled, the function should return   |
|  with XMK_TRUE, otherwise XMK_FALSE                                          |
|                                                                              |
|  Note:                                                                       |
|  The user has several possibilities to send signals to the environment by    |
|  using #EXTSIG,#ALT or #CODE, please view the reference manual.              |
|                                                                              |
|  Parameter    :  xmk_TmpSignalID        - ID of the signal (see .ifc file)   |
|                  xmk_TmpPrio            - Priority of signal                 |
|                  xmk_TmpDataLength      - Amount of bytes in signal's        |
|                                           parameters                         |
|                 *xmk_TmpDataPtr         - Pointer to signal's parameters     |
|                  xmk_TmpReceiverPID     - PID of the receiver.               |
|  Return       : Function must return with XMK_TRUE, if Signal was sent       |
|                 to the environment, otherwise with XMK_FALSE.                |
|                                                                              |
+------------------------------------------------------------------------------+
*/
xmk_OPT_INT   xOutEnv (xmk_T_SIGNAL xmk_TmpSignalID
                       #ifdef XMK_USE_SIGNAL_PRIORITIES
                        , xmk_T_PRIO xmk_TmpPrio
                       #endif
                       #ifdef XMK_USED_SIGNAL_WITH_PARAMS
                        , xmk_T_MESS_LENGTH xmk_TmpDataLength,
                         void xmk_RAM_ptr  xmk_TmpDataPtr
                       #endif
                       #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
                        , xPID xmk_TmpReceiverPID
                       #endif
                       )
{
  xmk_OPT_INT xmk_result = XMK_FALSE;

  /* BEGIN User Code (variable section)*/
  /* It is possible to define some variables here */

  char*   data;
  int     datalen, i;
  tBuffer Buf = 0;

  /*   END User Code (variable section)*/

  #ifdef XMK_ADD_MICRO_ENVIRONMENT
    xmk_T_CMD_EXT_OUTPUT_TO_ENV_IND cmd_data;
  #endif

  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("xOutEnv");
  #endif

  #ifdef XMK_ADD_PRINTF_ADDITIONAL
    PRINTF (("signal_id = %%d\n", xmk_TmpSignalID));
  #ifdef XMK_USE_SIGNAL_PRIORITIES
    PRINTF (("xmk_TmpPrio      = %%d\n", xmk_TmpPrio));
  #endif
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    PRINTF (("xmk_TmpDataLength  = %%d\n", xmk_TmpDataLength));
  #endif
  #endif /* ... XMK_ADD_PRINTF_USER */

  #ifdef XMK_ADD_MICRO_ENVIRONMENT
  /* BEGIN User Code (external env section)*/
  /*   END User Code (external env section)*/
  #endif /* ... XMK_ADD_MICRO_ENVIRONMENT */

  agent_addr.sin_family = AF_INET;
  agent_addr.sin_port = htons(161);
  agent_addr.sin_addr.s_addr = inet_addr("9.156.33.7"); /* network printer address */

  switch (xmk_TmpSignalID)
  {
     case snmp_request :
          {
            /* BEGIN User Code <snmp_request>_1 */
            /* Use (yPDP_snmp_request)xmk_TmpDataPtr to access the signal's parameters */
            /* ATTENTION: the data needs to be copied. Otherwise it */
            /*            will be lost when leaving xOutEnv */

			printf("Signal snmp_request: Encoding request... ");

			BufInitBuf( Buf, bms_SmallBuffer );
			ERSetRule( Buf, er_BER | er_Definite );
			BufInitWriteMode( Buf );
			BEREncode(Buf, (tASN1TypeInfo *)&yASN1_Message,(void *)&((yPDef_snmp_request *)xmk_TmpDataPtr)->Param1);
			BufCloseWriteMode( Buf );
			BufInitReadMode( Buf );
			datalen = BufGetDataLen( Buf );
			data = BufGetSeg( Buf, datalen );

			printf("Done!\n");

			printf("Signal snmp_request: datalen = %d, ", datalen);
			printf("   BER = ");
			for ( i = 0; i < datalen; i++ )
			{
			  printf("%x ", (unsigned char)data[i]);
			}
			printf("\n");

			printf("Signal snmp_request: Sending data... ");

#if defined(_Windows) || defined(WIN32)
			i = send(manager_sock, data, datalen, 0);
#else
			i = write(manager_sock, data, datalen);
#endif
			if ( i < 0 )
			{
#if defined(_Windows) || defined(WIN32)
			  exiterr("Signal snmp_request", "send");
#else
			  exiterr("Signal snmp_request", "read");
#endif
			}
			else if ( i < datalen )
			{
			  printf("Signal snmp_request:  WARNING : Only %d bytes sent\n", i);
			}

			BufCloseReadMode( Buf );
			BufCloseBuf(Buf);

			printf("Done!\n");

            /*   END User Code <snmp_request>_1 */

            /* BEGIN User Code <snmp_request>_2 */
            /* Do your environment actions here. */
            xmk_result = XMK_TRUE; /* to tell the caller that */
                                   /* signal is consumed      */
            /*   END User Code <snmp_request>_2 */
          }
          break ;

     case Init :
          {
            /* BEGIN User Code <Init>_1 */

			printf("Signal Init: Connecting to agent... ");
      
			if (connect(manager_sock,(struct sockaddr *)&agent_addr,sizeof(agent_addr)) != 0) 
			  exiterr("Signal Init", "Cannot connect to agent");

			fIsAgentConnected = 1;

			printf("Done!\n");

            /*   END User Code <Init>_1 */

            /* BEGIN User Code <Init>_2 */
            /* Do your environment actions here. */
            xmk_result = XMK_TRUE; /* to tell the caller that */
                                   /* signal is consumed      */
            /*   END User Code <Init>_2 */
          }
          break ;

     case Close :
          {
            /* BEGIN User Code <Close>_1 */

			printf("Signal Close: Closing... Done!\n");

			/*   END User Code <Close>_1 */

            /* BEGIN User Code <Close>_2 */
            /* Do your environment actions here. */
            xmk_result = XMK_TRUE; /* to tell the caller that */
                                   /* signal is consumed      */
            /*   END User Code <Close>_2 */
          }
          break ;

     default :
          xmk_result = XMK_FALSE;/* to tell the caller that */
                                 /* signal is NOT consumed  */
                                 /* and to be handled by    */
                                 /* the Cmicro Kernel ...   */
          break ;
  }

  #ifdef XMK_USE_SIGNAL_PRIORITIES
    XMK_SUPPRESS(xmk_TmpPrio);
  #endif
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    XMK_SUPPRESS(xmk_TmpDataLength);
    XMK_SUPPRESS(xmk_TmpDataPtr);
  #endif
  #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
    XMK_SUPPRESS(xmk_TmpReceiverPID);
  #endif

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("xOutEnv");
  #endif

  return (xmk_result);
} /* END OF FUNCTION */
#endif /* ... XMK_USE_xOutEnv */

#ifdef XMK_USE_xCloseEnv
/*
+------------------------------------------------------------------------------+
|  Functionname : xCloseEnv                                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called by the Cmicro Kernel after termination.             |
|  It is not that useful in a Cmicro controler application, but may be so in   |
|  a simulation with the Cmicro Package.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
void xCloseEnv (void)
{
  /* BEGIN User Code (variable section)*/
  /* It is possible to define some variables here */
  /*   END User Code (variable section)*/

  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("xCloseEnv");
  #endif

  /* BEGIN User Code (close section) */
  /* Do the actions here to close your environment */
  printf("CloseEnv: Closing manager socket...");

#if defined(_Windows) || defined(WIN32)
  closesocket(manager_sock);
#else
  close(manager_sock);
#endif

  manager_sock = -1;
  fIsAgentConnected = 0;
  
  printf("Done!\n");

  exit(0);
  /*   END User Code (close section) */

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("xCloseEnv");
  #endif
} /* END OF FUNCTION */
#endif /* ... XMK_USE_xCloseEnv */

#endif /* ... __ENV_C_ */
